/* Virginia Tech Cognitive Radio Open Source Systems
 * Virginia Tech, 2009
 *
 * LICENSE INFORMATION GOES HERE
 */

/* This header contains commonly used data container structs in VT-CROSS
 * systems.
 */

#ifndef CONTAINERS_H
#define CONTAINERS_H


#include <stdint.h>
#include <string>


struct CE_Info {
    uint32_t numUtilities;
    uint32_t numParameters;
    uint32_t numObservables;
    uint32_t policy_engine;
    uint32_t policy_socket;
    uint32_t ce_socket;
};

struct Utility {
    std::string name;
    std::string units;
    std::string goal;
    float target;
    float value;
};

struct Affect {
    Utility *u;
    std::string relation;
};

struct Parameter {
    std::string name;
    std::string units;
    float min;
    uint32_t numAffects;
    Affect affection_list[10];
    float max;
    float step;
    float value;
};

struct Observable {
    std::string name;
    Affect affection_list[10];
    uint32_t numAffects;
    float value;
};

#endif
